unit MultiplyPolinom;

interface

uses
  SysUtils, Classes, Controls, StdCtrls, Dialogs;

type
  TMultiplyPolinom = class(TCustomGroupBox)
  private
   FNameFile:string;
   FResult: TMemo;
  protected
   procedure SetFileName(value:string);
   procedure Calc;
  public
   constructor Create(AOwner:Tcomponent); override;
   destructor Destroy;  override;
  published
   property Height default 80;
   property Width default 300;
   property Top default 10;
   property Left default 10;
   property Caption;
   property FileName:string read FNameFile write SetFileName;
  end;

procedure Register;

implementation
Constructor TMultiplyPolinom.Create(AOwner:TComponent);
begin
 inherited Create(AOwner);
 Height:=80;
 Width:=300;
 Caption:=' :';
 FResult:=TMemo.Create(self);
  with Fresult do
   begin
    width:=280;
    Height:=60;
    Parent:=self;
    Top:=15;
    Left:=10;
    ReadOnly:=true;
   end;
end;

procedure TMultiplyPolinom.SetFileName(value:string);
begin
 FNameFile:=value;
 Calc;
end;

procedure TMultiplyPolinom.Calc;
var A,B,C:array of integer;
    f:textfile;
    i,j,k,m:integer;
 procedure PrintPolynom(count:integer;Arr:array of integer;prompt:string);
 var k:integer;
     s:string;
 begin
     s:=prompt;
     for k:=0 to count do
      begin
       if (k>0) and (Arr[k]>0) then s:=s+'+';
       if Arr[k]<>0 then
        begin
         s:=s+IntToStr(Arr[k]);
          if k=1 then s:=s+'*x'
           else if k>1 then s:=s+'*x^'+IntToStr(k);
        end;
      end;
     FResult.Lines.Add(s);
 end;
Begin
 if (FNameFile<>'') and fileexists(FNameFile) then
  begin
     assignfile(f,FNameFile);
     reset(f);
     i:=1;
     while not eoln(f) do
      begin
       SetLength(A,i);
       read(f,A[i-1]);
       inc(i);
      end;
     readln(f);
     j:=1;
     while not eoln(f) do
      begin
       SetLength(B,j);
       read(f,B[j-1]);
       inc(j);
      end;
     FResult.Clear;
     PrintPolynom(i-2,A,'1 :');
     PrintPolynom(j-2,B,'2 : ');
     SetLength(C,i+j-3);
     for k:=0 to i+j-4 do c[k]:=0;
     for k:=0 to i-2 do
      for m:=0 to j-2 do
       c[m+k]:=c[m+k]+a[k]*b[m];
     PrintPolynom(i+j-4,C,': ');
     closefile(f);
  end
  else FResult.Clear;
end;

destructor TMultiplyPolinom.Destroy;
begin
  FResult.free;
  inherited Destroy;
end;

procedure Register;
begin
  RegisterComponents('MyPage', [TMultiplyPolinom]);
end;

end.
